<?php

require_once 'lib/config/appConfig.class.php';
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of DateConversion
 *
 * @author guillermo
 */
class DateConversion {

    /**
     * Retorna objeto DateTime desde $value:String devuelto por RDBMS equivalente a un campo tipo fecha
     * @param type $value
     * @return DateTime
     */
    static public function DBFormatToDatetime($value) {
        if ($value != DbConfig::getDefaultNullDateTimeFormat()) {
            $_ret = DateTime::createFromFormat(DbConfig::getDefaultDateTimeFormat(), $value);
        } else {
            $_ret = null;
        }

        return $_ret;
    }

    /**
     * Retorna objeto DateTime desde $value:String devuelto por RDBMS equivalente a un campo tipo fecha
     * @param type $value
     * @return DateTime
     */
    static public function DBFormatToDate($value) {

        if ($value != DbConfig::getDefaultNullDateFormat()) {
            $_ret = DateTime::createFromFormat(DbConfig::getDefaultDateFormat(), $value);
        } else {
            $_ret = null;
        }

        return $_ret;
    }

    /**
     * Retorna objeto DateTime desde $value: String devuelto formulario (POST) equivalente a un campo tipo fecha en formato vista
     * @param type $value
     * @return DateTime
     */
    static public function ViewFormatToDatetime($value) {

        if ($value !== "") {

            if (strpos($value, "T") > 0)
                $_ret = new DateTime($value);
            else
                $_ret = DateTime::createFromFormat(appConfig::DEFAULT_DATETIME_FORMAT, $value);
        }else {
            $_ret = null;
        }
        return $_ret;
    }

    /**
     * Retorna objeto DateTime desde $value: String devuelto formulario (POST) equivalente a un campo tipo fecha en formato vista
     * @param type $value
     * @return DateTime
     */
    static public function ViewFormatToDate($value) {

        if ($value !== "") {
            if (strpos($value, "T") > 0)
                $_ret = new DateTime($value);
            else
                $_ret = DateTime::createFromFormat(appConfig::DEFAULT_DATE_FORMAT, $value);
        }else {
            $_ret = null;
        }
        return $_ret;
    }

    /**
     * Retorna String formteado en funci�n del parametro $datetime:DateTime con el formato indicado en appConfig::default_datetime_format
     * @param DateTime $date
     * @return String
     */
    static public function DateTimeToViewFormat($datetime) {
        $_ret = "";
        if ($datetime !== null && $datetime instanceof DateTime) {
            $_ret = $datetime->format(appConfig::DEFAULT_DATETIME_FORMAT);
        }
        return $_ret;
    }

    /**
     * Retorna String formteado en funci�n del parametro $date:DateTime con el formato indicado en appConfig::default_date_format
     * @param DateTime $date
     * @return String
     */
    static public function DateToViewFormat(DateTime $date) {
        $_ret = "";
        if ($date != null) {
            $_ret = $date->format(appConfig::DEFAULT_DATE_FORMAT);
        }
        return $_ret;
    }

    /**
     * Retorna String en funcion del parametro $date:DateTime y con formato especifico para el RDBMS
     * @param DateTime $date
     * @return String
     */
    static public function DateTimeToDBFormat(DateTime $datetime) {
        $_ret = "";
        if ($datetime != null) {
            $_ret = $datetime->format(DbConfig::getDefaultDateTimeFormat());
        }

        return $_ret;
    }

    /**
     * Retorna String en funcion del parametro $datetime:DateTime y con formato especifico para el RDBMS
     * @param DateTime $date
     * @return String
     */
    static public function DateToDBFormat(DateTime $date) {
        $_ret = "";
        if ($date != null) {
            $_ret = $date->format(DbConfig::getDefaultDateFormat());
        }

        return $_ret;
    }

}

?>
