<?php

require_once 'daoPersistRelationItem.php';
require_once 'daoPersistRelationItem_oneToMany.php';

/**
 * Description of daoPersistRelations
 *
 * @author gustavo
 */
class daoPersistRelations {
    
    protected $oneToOneRelationList;
    protected $oneToManyRelationList;
    protected $oneToOne_autoInstantiateRelationList;
    protected $oneToMany_autoInstantiateRelationList;

    function __construct(array $oneToOneRelations, array $oneToManyRelations ) {
        $this->oneToOneRelationList = $oneToOneRelations;
        $this->oneToManyRelationList = $oneToManyRelations;
    }

    public function setAutoInstantiateRelations($parentObject, $resultset){
        
        foreach ($this->oneToOneRelationList as $relation) {
            if($relation->autoInstantiate){
                $_pri = new daoPersistRelationItem($relation);
                $_pri->setObject($parentObject, $resultset);
                $this->oneToOne_autoInstantiateRelationList[$_pri->getClassName()] = $_pri;
            }
        }

        foreach ($this->oneToManyRelationList as $relation) {
            if($relation->autoInstantiate){
                $_pri = new daoPersistRelationItem_oneToMany($relation);
                $_pri->setObject($parentObject);
                $this->oneToMany_autoInstantiateRelationList[$_pri->getClassName()] = $_pri;
            }
        }

    }

    
    // TODO, separar getRelation --> getOneToOneRelation y getOneToManyRelation
    
    public function getRelation($propertyName){
        $_ret = null;

        foreach ($this->oneToOneRelationList as $relation) {
            if($relation->propertyName === $propertyName){
                $_ret = new daoPersistRelationItem($relation);
                break;
            }
        }

        foreach ($this->oneToManyRelationList as $relation) {
            if($relation->propertyName === $propertyName){
                $_ret = new daoPersistRelationItem_oneToMany($relation);
                break;
            }
        }

        return $_ret;
    }


    /**
     * @return array
     */
    public function getOneToOne_autoInstantiateRelationList() {
        return $this->oneToOne_autoInstantiateRelationList;
    }

    /**
     * @param mixed $oneToOneRelations
     */
    public function setOneToOne_autoInstantiateRelationList($oneToOneRelations) {
        $this->oneToOne_autoInstantiateRelationList = $oneToOneRelations;
    }

    /**
     * @return array
     */
    public function getOneToMany_autoInstantiateRelationList() {
        return $this->oneToMany_autoInstantiateRelationList;
    }

    /**
     * @param mixed $oneToManyRelations
     */
    public function setOneToMany_autoInstantiateRelationList($oneToManyRelations) {
        $this->oneToMany_autoInstantiateRelationList = $oneToManyRelations;
    }
    
    public function getOneToOneRelationList_onInnerJoinMode() {
        
        $_oToRelList = $this->oneToOneRelationList;
        $_ret = array();
        
        foreach ($_oToRelList as $_rel) {
            $_relObj = new daoPersistRelationItem($_rel);
            if ($_relObj->isInnerJoinMode())
                $_ret[] = $_relObj;
        }
        
        return $_ret;        
    }
    
    public function getOneToOneRelationList_onLeftJoinMode() {
        
        $_oToRelList = $this->oneToOneRelationList;
        $_ret = array();
        
        foreach ($_oToRelList as $_rel) {
            $_relObj = new daoPersistRelationItem($_rel);
            if ($_relObj->isLeftJoinMode())
                $_ret[] = $_relObj;
        }
        
        return $_ret;        
    }
    

}